#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
acceleration.py is supposed to take all the forces generated by force.py and...
add them together. Not the most glorious thing, but hey, it's an element that
can be plugged in and out.
"""

import numpy as np


def classic_acceleration(mass, *args):
    """ classic_acceleration really does just add all the forces together. 
    Inputs should be force matrices of equal sizes."""
    total_F = np.zeros_like(args[0])
    for F in args:
        total_F += F
    acc = total_F / np.reshape(mass, np.append(len(mass), 1))
    return acc